/* Problem URL: https://codeforces.com/contest/920/problem/G */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    vi div(1e6 + 1, 1);
    nrep(i, 2, 1e6 + 1) {
        if (div[i] > 1) {
            continue;
        }

        for (int j = i; j <= 1e6; j += i) {
            div[j] = i;
        }
    }

    int t;
    cin >> t;
    while (t--) {
        int x, p, k;
        cin >> x >> p >> k;

        vi primes;

        auto getprimes = [&]() {
            int tmp = p;
            while (tmp > 1) {
                primes.push_back(div[tmp]);
                int prime = div[tmp];

                while (tmp % prime == 0) {
                    tmp /= prime;
                }
            }
        };

        getprimes();

        auto getmuls = [&](ll now) {
            ll ans = 0;

            nrep(i, 1, 1 << primes.size()) {
                ll tmp = 1;

                rep(j, primes.size()) {
                    if ((i >> j) & 1) {
                        tmp *= primes[j];
                    }
                }

                if (__builtin_popcount(i) & 1) {
                    ans += now / tmp;
                } else {
                    ans -= now / tmp;
                }
            }

            return ans;
        };

        ll inv = getmuls(x);

        ll low = x + 1;
        ll high = 1e18;
        ll ans = 0;
        while (low <= high) {
            ll mid = ((high - low) >> 1) + low;

            ll act = getmuls(mid) - inv;
            if (mid - x - act >= k) {
                ans = mid;
                high = mid - 1;
                continue;
            }

            low = mid + 1;
        }

        while (__gcd(ans, (ll)p) != 1) {
            ans++;
        }

        cout << ans << '\n';
    }
}
